#!/usr/bin/python
# -*- coding: iso-8859-15 -*-

# buddy.py v1.0 (Praktikum, Arbeitsblatt 9)
#
# Vorlesung Betriebssysteme I
# Hans-Georg Eer, Hochschule Mnchen, SS 2009
# hans-georg.esser@hm.edu

# Globale Variablen

ram = []      # Liste mit den belegten / freien Blockgren
size = 0      # Gesamtgre des Speichers in KByte
ram_id = 1    # ID des nchsten vergebenen Blocks


def initialisieren (n):
  global size,ram,ram_id
  size = 2**n
  ram = [2**n]
  #for i in range(n):
  #  ram.append ( (2**i) * [0] )
  return

def vergeben (needed, pos):
  # diese Funktion nimmt an, dass bereits eine Zelle gefunden (aber
  # evtl. zu gro) ist. Bei Bedarf wird die Zelle solange in kleinere
  # Hlften geteilt, bis die richtige Gre erreicht ist
  global size,ram,ram_id
  ## print "vergeben, needed=%d, pos=%d" % (needed,pos)
  if ram[pos] == needed:
    # passt genau, also eintragen
    ram[pos] = (needed, ram_id)
    return
  else:
    # Speicherzelle aufteilen, z. B. [512] -> [256,256]
    t = ram[pos]    # Gre der gefundenen Zelle
    ram = ram[:pos] + [ t/2, t/2 ] + ram[pos+1:]
    # Rekursion: in linken Ast der geteilten Zelle eintragen
    vergeben (needed, pos)
    return

def anfordern (x):
  global size,ram,ram_id
  # kleinsten Block berechnen, in den x passt:
  needed = size*1024
  while needed > x:
    needed = needed / 2
  needed = needed * 2

  # kleinsten verfuegbaren Block suchen
  gefunden = 0
  search_size = needed
  while not gefunden:
    for pos in range(len(ram)):
      if ram[pos] == search_size:
        gefunden = 1
        vergeben (needed, pos)
    search_size = search_size * 2

  print "angefordert: %d, bentigt: %d, ID: %d" % (x, needed, ram_id)

  ram_id = ram_id+1
  return ram_id-1


def list():
  global size,ram,ram_id
  print ram


def freigeben(id):
  global size,ram,ram_id
  # Hier ist Platz fr Ihren Code :)
  #
  #
  return
  

# Hauptprogramm

initialisieren (9);  list()
a = anfordern (59);  list()
b = anfordern (27);  list()
c = anfordern (28);  list()
d = anfordern (115); list()
# freigeben (b);       list()
# freigeben (a);       list()
# freigeben (d);       list()
# freigeben (c);       list()

